//
//  AbstractSound.h
//  MQEditor
//
//  Created by groumpf on 13/08/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

typedef enum _SoundType {TYPE_UNKNOWN, TYPE_SOUND, TYPE_MULTI, TYPE_DRUMMAP} SoundType;

/*
	Classe abstraite pour les classes Sound, DrumMap et Multi.
	En fait tous les elements qui se composent d'un nom 
	et d'un ensemble de parametres.
*/
@interface AbstractSound : NSObject 
{
	NSString *patchName;

	uint8_t *parameters;
}

- (id)initSize:(int)aSize;

- (int)nameIndex;
- (int)nameLength;

// la taille du bloc sauvegarde (voir MIDIDriver)
- (int)size;

- (SoundType)type;


- (NSString*)patchName;
- (void)setPatchName:(NSString*)aName;

- (uint8_t*)patch;
- (NSData *)data;

- (id)initWith:(uint8_t*)aPatch;
- (id)initWithData:(NSData*)data;
- (void)setParameter:(int)aParameterNumber Value:(int)aValue;
- (int)getParameter:(int)aParameterNumber;


@end
